@echo off

:main
	setlocal
	if "%1"=="" (
		echo Installing artifacts locally
		set maven_op=install:install-file
		call :do_it
	) else if "%2"=="" (
		echo Usage: install_artifacts [repository_id repository_url]
	) else (
		echo Deploying artifacts to server %1
		set maven_op=package deploy:deploy-file -DrepositoryId=%1 -Durl=%2
		call :do_it
	)
	endlocal
exit /b 0

:do_it
	call :install_projects
	call :loop_for_artifacts
exit /b 0

:install_projects
	call :install_project net.sourceforge.sharkwf.shark-core
	call :install_project net.sourceforge.sharkwf.shark-hsql-emptydb
	call :install_project net.sourceforge.sharkwf.shark-embedded
	call :install_project net.sourceforge.sharkwf.shark-ws-plain
exit /b 0

:install_project
	setlocal
	set BASE_WD=%CD%
	set PROJECT_PATH=%1:.=\%
	cd %PROJECT_PATH%
	mvn %maven_artop% clean
	cd %BASE_WD%
	endlocal
exit /b 0

:loop_for_artifacts
	setlocal
	for /f "usebackq tokens=1,2,3,4" %%i in ("artifact-list.txt") do (
		call :install_artifact %%i %%j %%k %%l
	)
	endlocal
exit /b 0

:install_artifact
	setlocal
	set groupId=%1
	set artifactId=%2
	set version=%3
	set packaging=%4
	set jarpath=%groupId:.=\%

	call mvn %maven_op% -Dfile=%jarpath%\%artifactId%-%version%.%packaging% -DgroupId=%groupId% -DartifactId=%artifactId% -Dversion=%version% -Dpackaging=%packaging%
	endlocal
exit /b 0

call :main
